Subject: Re: bug#65206: 29.1; [windows][patch] build-deps-zips.py is broken and hard to maintain

From: Eli Zaretskii <[email-masked]>
Date: Tue, 15 Aug 2023 19:01:53 +0300

> From: Corwin Brust <[email-masked]>
> Date: Tue, 15 Aug 2023 10:53:55 -0500
> Cc: [email-masked]
> 
> > Thanks.  What I still don't think I understand is how do you make sure
> > you have a full list of first-order dependencies?  I understand that
> > you mostly build on the "last good" list from previous release, but
> > since the list grows from time to time, what is the procedure for
> > finding the new dependencies, adding them to the list, and making sure
> > they all are there?
> >
> > I'm asking because this is exactly where the procedure broke down when
> > we added WebP image support in Emacs 29.
> 
> The above quote from myself I retained is my best/only answer:
> 
> I update the script as issues are reported or when I somehow otherwise
> learn that changes are needed.  I have no real process for this, and
> nothing in the tooling is helping me with it, so far.

OK, so here's a suggestion which might improve that crucial part: scan
the list in dynamic-library-alist, on lisp/term/w32-win.el.  Every
dependency that is loaded dynamically (i.e., Emacs is not linked
against it when it is built) must be in that list.  So when we add
dependencies, we add them there.

I believe that given a full and complete lest of first-order
dependencies, those which Emacs actually loads, all the higher-order
dependencies can be found by following the MSYS2 pacman etc., is that
right?